Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -22,4 +22,4 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -22,4 +22,4 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -22,4 +22,4 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Kimono1_1920x1080_24.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Kimono1_1920x1080_24.yuv
@@ -22,4 +22,4 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Kimono1_1920x1080_24.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -22,4 +22,4 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : PeopleOnStreet_2560x1600_30_crop.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : PeopleOnStreet_2560x1600_30_crop.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-2x.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Traffic_2560x1600_30_crop.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20
Index: branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-SNR.cfg
===================================================================
--- branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 217)
+++ branches/SHM-2.0avc-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 221)
@@ -12,5 +12,5 @@
 IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
-QP0: 22
+QP0                           : 22
 
 InputFile1                    : Traffic_2560x1600_30_crop.yuv
@@ -22,3 +22,3 @@
 NumDirectRefLayers1           : 1           # number of direct reference layers
 RefLayerIds1                  : 0           # reference layer id
-QP1: 20
+QP1                           : 20