Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibCommon/TypeDef.h	(revision 227)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibCommon/TypeDef.h	(revision 228)
@@ -145,4 +145,5 @@
 ///// ***** QUADTREE LIMITATION *********
 #define OL_QTLIMIT_PREDCODING_B0068       1    //JCT3V-B0068
+#define HHI_QTLPC_RAU_OFF_C0160           1   // JCT3V-C0160 change 2: quadtree limitation and predictive coding switched off in random access units 
 
 ///// ***** OTHERS *********
Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 227)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 228)
@@ -762,5 +762,10 @@
   Bool bIntraSliceDetect  = (pcCU->getSlice()->getSliceType() == I_SLICE);
 
+#if HHI_QTLPC_RAU_OFF_C0160
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+#else
   if(bDepthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC())
+#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());
@@ -804,5 +809,10 @@
   Bool bIntraSliceDetect = (pcCU->getSlice()->getSliceType() == I_SLICE);
 
+#if HHI_QTLPC_RAU_OFF_C0160
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+#else
   if(bDepthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC())
+#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());
Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 227)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 228)
@@ -458,4 +458,8 @@
   Bool  bIntraSliceDetect = (rpcBestCU->getSlice()->getSliceType() == I_SLICE);
 
+#if HHI_QTLPC_RAU_OFF_C0160
+  Bool rapPic     = (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+#endif
+
   Bool bTry2NxN = true;
   Bool bTryNx2N = true;
@@ -612,5 +616,10 @@
 #if OL_QTLIMIT_PREDCODING_B0068
       //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
+
+#if HHI_QTLPC_RAU_OFF_C0160
+      if(depthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+#else
       if(depthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC())
+#endif
       {
         TComDataCU* pcTextureCU = pcTexture->getCU( rpcBestCU->getAddr() ); //Corresponding texture LCU
@@ -719,5 +728,10 @@
 
 #if OL_QTLIMIT_PREDCODING_B0068
+
+#if HHI_QTLPC_RAU_OFF_C0160
+      if(depthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+#else
       if(depthMapDetect && !bIntraSliceDetect  && sps->getUseQTLPC())
+#endif
       {
         bTrySplitDQP = bTrySplit;
Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 227)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 228)
@@ -625,5 +625,10 @@
   Bool bIntraSliceDetect = (pcCU->getSlice()->getSliceType() == I_SLICE);
  
+#if HHI_QTLPC_RAU_OFF_C0160
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
+#else
   if(bDepthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
+#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());
@@ -924,5 +929,10 @@
   Bool bIntraSliceDetect = (pcCU->getSlice()->getSliceType() == I_SLICE);
 
+#if HHI_QTLPC_RAU_OFF_C0160
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
+#else
   if(bDepthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
+#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());