Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 228)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 229)
@@ -763,5 +763,5 @@
 
 #if HHI_QTLPC_RAU_OFF_C0160
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
 #else
@@ -810,5 +810,5 @@
 
 #if HHI_QTLPC_RAU_OFF_C0160
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
 #else
Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 228)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 229)
@@ -459,5 +459,5 @@
 
 #if HHI_QTLPC_RAU_OFF_C0160
-  Bool rapPic     = (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  Bool rapPic     = (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
 #endif
 
@@ -1119,5 +1119,5 @@
       if ( !bEarlySkip 
 #if HHI_DEPTH_INTRA_SEARCH_RAU_C0160
-        || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR))
+        || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA))
 #endif
         )
@@ -1130,5 +1130,5 @@
           rpcBestCU->getCbf( 0, TEXT_CHROMA_V ) != 0 
 #if HHI_DEPTH_INTRA_SEARCH_RAU_C0160
-          || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR))
+          || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA))
 #endif            
           ) && !bFullyRenderedSec ) // avoid very complex intra if it is unlikely
@@ -1139,5 +1139,5 @@
           rpcBestCU->getCbf( 0, TEXT_CHROMA_V ) != 0     
 #if HHI_DEPTH_INTRA_SEARCH_RAU_C0160
-          || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR))
+          || ((rpcBestCU->getSlice()->getIsDepth() == true) && (rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || rpcBestCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA))
 #endif     
           ) // avoid very complex intra if it is unlikely
Index: /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 228)
+++ /branches/HTM-5.1-dev1-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 229)
@@ -626,5 +626,5 @@
  
 #if HHI_QTLPC_RAU_OFF_C0160
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
 #else
@@ -930,5 +930,5 @@
 
 #if HHI_QTLPC_RAU_OFF_C0160
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR);
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC() && pcCU->getPic()->getReduceBitsFlag())
 #else