Index: /branches/SHM-2.1-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibCommon/TypeDef.h	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibCommon/TypeDef.h	(revision 238)
@@ -56,5 +56,4 @@
 #define VPS_EXTN_PROFILE_INFO            1      ///< Include profile information for layer sets in VPS extension
 #define VPS_EXTN_DIRECT_REF_LAYERS       1      ///< Include indication of direct dependency of layers in VPS extension
-#define VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE   1
 #define VPS_OUTPUT_LAYER_SET_IDX         1      ///< M0268: Signal output_layer_set_idx[i] as output_layer_set_idx_minus1[i]
 #define VPS_MOVE_DIR_DEPENDENCY_FLAG     1      ///< M0268: Move the syntax element direct_dependency_flag to follow the syntax element dimension_id
Index: /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 238)
@@ -247,5 +247,5 @@
     for (Int iRefIndex = 0; iRefIndex < pcSlice->getNumRefIdx(RefPicList(iRefList)); iRefIndex++)
     {
-#if REF_IDX_FRAMEWORK && VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if REF_IDX_FRAMEWORK && VPS_EXTN_DIRECT_REF_LAYERS
       if( pcSlice->getRefPic(RefPicList(iRefList), iRefIndex)->isILR( m_layerId ) )
       {
Index: /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 238)
@@ -248,5 +248,5 @@
     if(m_layerId > 0)
     {
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
       TDecTop *pcTDecTopBase = (TDecTop *)getRefLayerDec( m_layerId );
 #else
@@ -822,5 +822,5 @@
       else
       {
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
         TDecTop *pcTDecTop = (TDecTop *)getRefLayerDec( m_layerId );
 #else
@@ -831,5 +831,5 @@
       }
 #else
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
       TDecTop *pcTDecTop = (TDecTop *)getRefLayerDec( m_layerId );
 #else
@@ -1273,5 +1273,5 @@
 }
 
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
 TDecTop* TDecTop::getRefLayerDec( UInt layerId )
 {
Index: /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 238)
@@ -156,5 +156,5 @@
   Void      setLayerDec(TDecTop **p)    { m_ppcTDecTop = p; }
   TDecTop*  getLayerDec(UInt layer)     { return m_ppcTDecTop[layer]; }
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
   TDecTop*  getRefLayerDec(UInt layerId);
 #endif
Index: /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 238)
@@ -535,5 +535,5 @@
     if (m_layerId > 0)
     {
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
       TComList<TComPic*> *cListPic = m_ppcTEncTop[m_layerId]->getRefLayerEnc(m_layerId)->getListPic();
 #else
@@ -2631,5 +2631,5 @@
     for (Int iRefIndex = 0; iRefIndex < pcSlice->getNumRefIdx(RefPicList(iRefList)); iRefIndex++)
     {
-#if REF_IDX_FRAMEWORK && VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if REF_IDX_FRAMEWORK && VPS_EXTN_DIRECT_REF_LAYERS
       if( pcSlice->getRefPic(RefPicList(iRefList), iRefIndex)->isILR(m_layerId) )
       {
Index: /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 238)
@@ -507,5 +507,5 @@
       if(m_layerId > 0)
       {
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
         TEncTop *pcEncTopBase = (TEncTop *)getRefLayerEnc( m_layerId );
 #else
@@ -535,5 +535,5 @@
       if(m_layerId > 0)
       {
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
         TEncTop *pcEncTopBase = (TEncTop *)getRefLayerEnc( m_layerId );
 #else
@@ -1192,5 +1192,5 @@
 
 #if SVC_EXTENSION
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
 TEncTop* TEncTop::getRefLayerEnc( UInt layerId )
 {
Index: /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 237)
+++ /branches/SHM-2.1-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 238)
@@ -230,5 +230,5 @@
   Void      encode( TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int iPicIdInGOP  );
   Void      encodePrep( TComPicYuv* pcPicYuvOrg );
-#if VPS_EXTN_DIRECT_REF_LAYERS_CONTINUE
+#if VPS_EXTN_DIRECT_REF_LAYERS
   TEncTop*  getRefLayerEnc(UInt layerId);
 #endif